<template>
  <div :class="[$style.searchView, $style[isSearching ? 'searching' : '']]">
    <search-block
      @on-search="setCurrentSearchQuery($event)"
      :isMobile="true"
    ></search-block>
    <div v-if="currentQuery && totalBooksCount !== 0" :class="$style.booksList">
      <book-list :books="books" />
      <infinite-loading @infinite="infiniteHandler"></infinite-loading>
    </div>
  </div>
</template>

<script>
import { SearchBlock, BookList } from "@/components";

export default {
  name: "SearchMobileView",
  components: { SearchBlock, BookList },
  data() {
    return {
      currentPage: 1,
      currentQuery: "",
      maxResults: 8
    };
  },
  computed: {
    books() {
      return this.$store.getters.bookList;
    },
    totalBooksCount() {
      return this.$store.getters.totalCount;
    },
    isSearching() {
      return this.currentQuery.length > 0;
    }
  },
  methods: {
    setCurrentSearchQuery(query) {
      this.currentQuery = query;
      this.currentPage = 1;
      this.getBookList();
    },
    getBookList() {
      const params = {
        q: this.currentQuery,
        startIndex: this.currentPage - 1,
        maxResults: this.maxResults
      };
      this.$store.dispatch("getBookList", params);
    },
    async infiniteHandler($state) {
      if (this.books.length < this.totalBooksCount) {
        this.currentPage++;
        const params = {
          q: this.currentQuery,
          startIndex: this.currentPage - 1,
          maxResults: this.maxResults
        };
        await this.$store.dispatch("uploadMoreBooks", params);
        $state.loaded();
      } else {
        $state.complete();
      }
    }
  }
};
</script>

<style lang="scss" module>
@import "../../shared/styles/imports.scss";

.searchView {
  padding: 64px;
  display: flex;
  flex-direction: column;
  text-align: left;

  .booksList {
    flex: 1;
    margin-top: 45px;
  }

  @include onScreenRes($mobileLandscapeAndLower) {
    padding: 24px 16px;
  }

  &.searching {
    min-height: 100vh;
    background-color: white;
  }
}

.pagination {
  display: flex;
  justify-content: center;
  margin-top: 50px;
}
</style>
